<template>
  <div class="box p-5 md:p-8 mb-10">
    <form @submit.prevent="form.post('/leave/leaveApplication', { preserveScroll: true })" autocomplete="off">
      <h3>Apply for Leave</h3>

      <div class="border border-dashed border-gray-400 p-3 my-3">
        <div class="text-base text-gray-500">
          <Icon icon="fa-solid fa-running"></Icon>
          <p class="inline-block ml-3 font-bold">Leave Balance</p>
        </div>
        <div class="mt-5 text-base space-y-3">
          
         <div class="flex items-center mb-4">
            
         </div>
         <div class="md:flex gap-x-4 flex-col md:flex-row space-y-5 md:space-y-0 mt-10 mb-3 overflow-auto">
            <div v-for="balance in user.balances" class="balance-card bg-blue-100 p-4 rounded-lg shadow-lg flex flex-col items-center justify-center w-40 h-24">
               <span class="italic text-gray-700 text-sm">{{ balance.leave_type.type }}</span>
               <span class="font-bold text-gray-800 text-base">{{ balance.balance }}</span>
            
          
         </div>
      </div>
          
        </div>
      </div>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">Leave Type
              </label>
              <multiselect v-model="form.leave_type" :multiple="false" :options="leaveTypes" label="name" track-by="id"
                :customLabel="(lt) => `${lt.type}`">
              </multiselect>
              <div v-if="form.errors.leave_type" class="text-error">
                {{ form.errors.leave_type }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div v-if="form.leave_type.balance_type === 'Public Holiday'">
        <multiselect v-model="form.public_holidays" :multiple="true" :options="form.leave_type.public_holidays"
          label="name" track-by="date"
          :customLabel="(ph) => `${ph.name} (${new Date(ph.date).toLocaleString('default', { month: 'long' })} ${new Date(ph.date).getDate()})`">
        </multiselect>
        <div v-if="form.errors.public_holidays" class="text-error">
          {{ form.errors.public_holidays }}
        </div>
        <div v-for="i in form.leave_type.public_holidays.length">
          <div v-if="form.errors[`public_holidays.${i - 1}.name`]" class="text-error">
            {{ form.errors[`public_holidays.${i - 1}.name`] }}
          </div>
        </div>
      </div>


      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full md:w-1/2 mr-2">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                Start Date</label>
              <input id="name" class="input w-full" type="date" v-model="form.start_date" />
              <div v-if="form.errors.start_date" class="text-error">
                {{ form.errors.start_date }}
              </div>
            </div>
            <div class="flex flex-col w-full md:w-1/2">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                End Date</label>
              <input id="name" class="input w-full" type="date" v-model="form.end_date" />
              <div v-if="form.errors.end_date" class="text-error">
                {{ form.errors.end_date }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">Description
              </label>
              <textarea v-model="form.description" class="w-full textarea"
                placeholder="Enter body for your leave application"></textarea>
              <div v-if="form.errors.description" class="text-error">
                {{ form.errors.description }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="mt-3">
        <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">Leave Approvers
        </label>

        <div v-if="form.leave_type.requires_hod_approval && hod">
          <span class="text-sm mr-2">Stage 0:</span>
          <Icon icon="fa-solid fa-user" class="text-sm text-gray-500"></Icon>
          <span class="text-sm">{{ hod.name }} (Head of Department)</span>
        </div>
        <div
          v-for="approvalStage in form.leave_type.approval_stages.sort((stageA, stageB) => stageA.stage - stageB.stage)">
          <span class="text-sm mr-2">Stage {{ approvalStage.stage }}:</span>
          <Icon icon="fa-solid fa-user" class="text-sm text-gray-500"></Icon>
          <span class="text-sm">{{ approvalStage.user.name }} ({{ approvalStage.user.role.name }})</span>
        </div>
        <div class="text-sm" v-if="form.leave_type.approval_stages.length === 0">
          No Approvers found!
        </div>
      </div>


      <div class="flex gap-x-3 mt-3 flex-row-reverse">
        <div class="flex justify-end mt-4">
  <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
  <Link href="/leave/leaveApplication" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
</div>

      </div>
    </form>
  </div>
</template>

<script setup>
import { Link, useForm } from '@inertiajs/vue3';

const props = defineProps({
  leaveTypes: Array,
  hod: Object,
  user: Object
})

const form = useForm({
  leave_type: props.leaveTypes[0] ?? null,
  start_date: null,
  end_date: null,
  description: '',
  public_holidays: []
});
</script>